<template>
  <v-container>
    <v-row>
      <v-col cols="5">
        <v-btn @click="doAdd">Add New</v-btn>
      </v-col>
      <v-col cols="7">
        <h1>Menu</h1>
      </v-col>
    </v-row>
    <v-row>
      <v-col cols="12">
        <v-data-table
            :headers="headers"
            :items="formApps"
            :search="search"
            :custom-filter="doSearch"
        >
          <template v-slot:top>
            <v-text-field
                v-model="search"
                label="Search (UPPER CASE ONLY)"
                class="mx-4"
            ></v-text-field>
          </template>
          <template v-slot:[`item.actions`]="{ item }">
            <v-icon small class="mr-2" @click="doEdit(item.id, item.form_type)">mdi-pencil</v-icon>
            <v-icon small @click="doDelete(item)">mdi-delete</v-icon>
          </template>
        </v-data-table>
      </v-col>
    </v-row>
    <FormAppForm ref="dlg" />
    <DlgMsg ref="dlgMsg" />
    <Loading ref="loading" :dlg-loading="statusProgress" />
  </v-container>
</template>

<script>
import DlgMsg from "../components/dialog/DlgMsg";
import Loading from "../components/dialog/Loading";
import FormAppForm from "../components/FormAppForm";
import formAppService from "../service/FormAppService";
import {checkError404} from "../utils/util";

export default {
  name: "Menu",
  components: {
    FormAppForm,
    DlgMsg,
    Loading,
  },
  data: function () {
    return {
      search: '',
      formApps: [],
      title: null,
      headers: [
        { text: "ACTION", align: "center", value: "actions", sortable: false },
        { text: "NO.", align: "center", value: "number", sortable: false },
        { text: "TYPE", align: "left", value: "form_type", sortable: true },
        { text: "NAME", align: "left", value: "name", sortable: true },
        { text: "FORM PATH", align: "left", value: "form", sortable: true },
        { text: "CREATE DATE", align: "center", value: "create_at", sortable: true },
        { text: "UPDATE DATE", align: "center", value: "update_at", sortable: true },
      ],
      dialogAdd: false,
      statusProgress: false,
    }
  },
  methods: {
    doSearch(value, search) {
      return value != null &&
          search != null &&
          typeof value === 'string' &&
          value.toString().toUpperCase().indexOf(search) !== -1
    },
    doAdd() {
      let title = "Add New Form Aplikasi"
      this.$refs.dlg.doAdd(title, false)
    },
    async doDelete(data) {
      if (!await this.$refs.dlgMsg.confirm(`Apakah Ingin Menghapus Data MENU ${data.id} - ${data.name}`)) {
        return false;
      }

      await formAppService.delete(data.id, data.form_type).then(async resp => {
        let {message, status} = resp.data
        if (status === 'SUCCESS') {
          await this.doRefresh()
        }
        this.$refs.dlgMsg.doOpenMsg(message)
      }).catch(ex => {
        checkError404(ex, this.$refs.dlgMsg)
      })
    },
    doEdit(id, form_type) {
      let title = "Edit Form Aplikasi"
      let dataPk = {
        id: id,
        form_type: form_type
      }
      this.$refs.dlg.doEdit(dataPk, title, true)
    },
    async doRefresh() {
      this.formApps = []
      await formAppService.getAll().then(resp => {
        let {data, message, status} = resp.data
        if (status === 'SUCCESS') {
          let number = 1;
          for (let formApp of data) {
            formApp.number = number++
            this.formApps.push(formApp)
          }
        } else {
          this.$refs.dlgMsg.doOpenMsg(message)
        }
      }).catch(ex => {
        checkError404(ex, this.$refs.dlgMsg)
      })
    },
  },
  async mounted() {
    this.statusProgress = true
    await this.doRefresh()
    this.statusProgress = false
  },
}

</script>

<style scoped>

</style>